import java.net.URI;
import java.util.ArrayList;
import java.util.regex.Pattern;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import static java.nio.file.StandardOpenOption.*;

import java.nio.charset.Charset;
import java.nio.file.*;
import java.io.*;


public class XMLReaderStub {


	public NodeList designPatternParser(String XMLfilePath, String patternName, String roleName) throws ParserConfigurationException, SAXException, XPathExpressionException{
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();

		NodeList nodeList = null;
		try{
			//Document doc = builder.parse("Lucene300DesignPatterns.xml");
			Document doc = builder.parse(XMLfilePath);
			doc.getDocumentElement().normalize();

			System.out.println("Root element :" + doc.getDocumentElement().getNodeName());

			XPathFactory xPathfactory = XPathFactory.newInstance();
			XPath xpath = xPathfactory.newXPath();

			//Select the class instances (patternClassName) involved in a  pattern of a given type (patternName)
			
			XPathExpression expr = xpath.compile("/system//pattern[@name='Prototype']//instance//role[@element='org.apache.lucene.search.spans.SpanQuery']");
			//XPathExpression expr = xpath.compile("/system//pattern[@name='Prototype']//instance//role[@name='Client']");
			
			//XPathExpression expr = xpath.compile("/system//pattern[@name='"+patternName+"']//instance//role[@name='"+roleName+"']");
			nodeList = (NodeList)expr.evaluate(doc,XPathConstants.NODESET);
		}catch(IOException e){
			e.getMessage();}

		return nodeList;
	}

	/*
	 * Create/write and save a file of all the classes that play a given role in a given pattern. NodeList contains them 
	 * @parms
	 */
	public void saveDP_Classes(NodeList nodeList, String fullOutputListPath) throws IOException{
		Path path = Paths.get(URI.create("file://"+fullOutputListPath));	

		// create a file with column headers 
		byte data_0[];
		String line_0 = new String("Pattern name,class name"+'\n');
		data_0 = line_0.getBytes();		
		try(OutputStream out_0 = new BufferedOutputStream(Files.newOutputStream(path, CREATE))) {
			out_0.write(data_0, 0, data_0.length);
		}catch(IOException x) {System.err.println(x);}

		//write the list of classes in design patterns into a file; assign them the pattern name and role and a unique number to be used with FANMOD
		String myDesignPattern = null;
		NamedNodeMap classList = null;
		NamedNodeMap  parent = null;
		String line = null;
		ArrayList<String> check = new ArrayList<String>();
		check.add(0,line_0);
		String cutLine = null;
		for (int i=0; i<nodeList.getLength();i++) {
			// get the name of the design pattern
			parent =  nodeList.item(i).getParentNode().getParentNode().getAttributes();
			System.out.println("Pattern type: "+parent.item(0).getNodeValue());
			myDesignPattern = parent.item(0).getNodeValue();
			//get the attributes of the node i. Node "i"s are all the nodes that are "role" in the XML file. 
			//they include classes and methods. teh attributes are the name of the pattern and the name of the class
			classList = nodeList.item(i).getAttributes();
			System.out.println("Design pattern: "+myDesignPattern+" Class name: "+classList.item(0).getNodeValue()+" Class type: "+classList.item(1).getNodeValue());
			line = new String(myDesignPattern+":"+classList.item(0).getNodeValue()+'\r');
			//use the regular expression to change the separator from ":" to "," so that I can save the data in a ".csv" file
			Pattern column = Pattern.compile(":");
			String[] tokens= column.split(line);
			cutLine = tokens[0]+","+tokens[1]+'\r';
			System.out.println(tokens[0]+", "+tokens[1]+'\r');
			check.add(i+1,tokens[0]+","+tokens[1]);
			try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(path, APPEND))) {
				byte data[] = cutLine.getBytes();
				out.write(data, 0, data.length); 
			}catch(IOException x) {System.err.println(x);}	
		}
		//Another way to write directly the the ArrayList into the file. use only one of the two. The first one write line by line the second one writes the whole ArrayList. 
//		try{
//			Path out = Paths.get(fullOutputListPath);
//			Files.write(out,check,Charset.defaultCharset());
//		}catch(IOException x){ System.err.println(x);}
	}

}

